/*

  Comparator
  Taken from red_black_tree, this should properly be shared, when the
  red black tree implementation is fixed 

  Authors: Bo Simonsen, June 2008

*/

namespace cphstl {
  template <typename K, typename V, typename C>
  class _value_compare
    : public std::binary_function<V, V, bool> {
  public:
    typedef K key_type;
    typedef V value_type;
    typedef C key_compare;

    bool operator()(value_type const& x, value_type const& y) const {
      cphstl::unnamed::key_map<key_type, value_type> key;
      return comparator(key[x], key[y]);
    }
  protected:
    _value_compare(key_compare const& predicate)
      : comparator(predicate) {
    }

    key_compare comparator;
  };

}
