/*

  Functors

  Authors: Bo Simonsen, June 2008

*/



namespace cphstl {

  /* Functors used for find_node */

  template<typename K, typename V, typename F, typename C, typename A, typename N, bool is_multiset>
  class f_lowerbound {
  public:
    typedef N node_type; 
    typedef K key_type;
    typedef F functor_type;

    bool operator()(const avl_tree<K, V, F, C, A, N,is_multiset>& r, node_type* x, const key_type& k) {
      key_type x_key = functor_type()(x->content());
      return !r.comparator(x_key, k);
    }
  };

  template<typename K, typename V, typename F, typename C, typename A, typename N, bool is_multiset>
  class f_upperbound {
  public:
    typedef N node_type; 
    typedef K key_type;
    typedef F functor_type;

    bool operator()(const avl_tree<K, V, F, C, A, N,is_multiset>& r, node_type* x, const key_type& k) {
      key_type x_key = functor_type()(x->content());
      return r.comparator(k, x_key);
    }
  };
}
