/*

  AVL node class

  Authors: Bo Simonsen, June 2008

*/

#include <string>
#include <iostream>

namespace cphstl {
  template <typename V>
  class avl_tree_node {
  public:
    typedef V value_type;
    typedef avl_tree_node<value_type> node_type;

  private:
    node_type* _parent;
    node_type* _left;
    node_type* _right;

    /* Pointers for an internal linked list which makes it possible to do iterator operations
       in O(1) time. */

    node_type* _prev;
    node_type* _next;

    short _balance;
    value_type _data;
      
  public:
    node_type*& parent() {
      return (*this)._parent;
    }
    node_type*& left() {
      return (*this)._left;
    }
    node_type*& right() {
      return (*this)._right;
    }
    node_type*& successor() {
      return (*this)._next;
    }
    node_type*& predecessor() {
      return (*this)._prev;
    }
    node_type* successor() const {
      return (*this)._next;
    }
    node_type* predecessor() const {
      return (*this)._prev;
    }
    short& balance() {
      return (*this)._balance;
    }
    value_type& content() {
      return _data; 
    }
    const value_type& content() const {
      return _data;
    }      
    operator std::string() const {
    /*  std::stringstream ss, _ss;
      std::string balance_str;
      std::string data_str;

      ss << balance;
      ss >> balance_str;

      _ss << data;
      _ss >> data_str;

      std::string ret = "";
       
      if(left != 0) {
        ret += "Left\n" + (std::string) *left;
      } 

      ret += "Node: " + data_str + " balance: " + balance_str + "\n";

      if(right != 0) {
        ret += "Right\n" + (std::string) *right;
      } 

      return ret;*/
    } 
  };
}
