/*
  A definition of the "Entry" class for dynamic array which should be customizing the
  container (it's given as template parameter).

  The current use is only iterator related.

  Author: Bo Simonsen, May 2008

*/



namespace cphstl
{
  template <typename V, typename A>
  class dynamic_array_entry {
  public:
    typedef V value_type;
    typedef std::ptrdiff_t difference_type;

    value_type v;

    dynamic_array_entry(value_type const& _v) {
      v = _v;
    }

    dynamic_array_entry* advance(difference_type const n) {
      return this + n;
    }
    dynamic_array_entry const* advance(difference_type const n) const {
      return this + n;
    }

    const value_type& content() const {
      return v;
    }
    value_type& content() {
      return v;
    }
    difference_type distance(dynamic_array_entry const* a) const {
      return a - this; 
    }
    bool equal(dynamic_array_entry const* a) const {
      return this == a;
    }
  };
}

