/*
  An implementation of cphstl::list_based_stack

  Authors: Jyrki Katajainen and Johannes Serup, March 2008
*/

namespace cphstl {

  // explicit constructor

  template <typename V, typename A, typename R, typename I, typename J>
  list_based_stack<V, A, R, I, J>::list_based_stack(A const& a) : list(a) {
  }

  // copy constructor

  template <typename V, typename A, typename R, typename I, typename J>
  list_based_stack<V, A, R, I, J>::list_based_stack(list_based_stack<V, A, R, I, J> const& c)
    : list(c.list) {
  }

  // destructor

  template <typename V, typename A, typename R, typename I, typename J>
  list_based_stack<V, A, R, I, J>::~list_based_stack() {
  }

  // operator=

  template <typename V, typename A, typename R, typename I, typename J>
  list_based_stack<V, A, R, I, J>&
  list_based_stack<V, A, R, I, J>::operator=(list_based_stack<V, A, R, I, J> const& c) {
    (*this).list = c.list;
    return *this;
  }

  // iterator begin

  template <typename V, typename A, typename R, typename I, typename J>
  typename list_based_stack<V, A, R, I, J>::iterator
  list_based_stack<V, A, R, I, J>::begin() {
    return (*this).list.begin();
  }

  template <typename V, typename A, typename R, typename I, typename J>
  typename list_based_stack<V, A, R, I, J>::const_iterator
  list_based_stack<V, A, R, I, J>::begin() const {
    return const_iterator((*this).list.begin());
  }

  // iterator end
	
  template <typename V, typename A, typename R, typename I, typename J>
  typename list_based_stack<V, A, R, I, J>::iterator
  list_based_stack<V, A, R, I, J>::end() {
    return (*this).list.end();
  }	
	
  template <typename V, typename A, typename R, typename I, typename J>
  typename list_based_stack<V, A, R, I, J>::const_iterator
  list_based_stack<V, A, R, I, J>::end() const {
    return const_iterator((*this).list.end());
  }
	
  // size

  template <typename V, typename A, typename R, typename I, typename J>
  typename list_based_stack<V, A, R, I, J>::size_type
  list_based_stack<V, A, R, I, J>::size() const {
    return (*this).list.size();
  }

  // max_size

  template <typename V, typename A, typename R, typename I, typename J>
  typename list_based_stack<V, A, R, I, J>::size_type
  list_based_stack<V, A, R, I, J>::max_size() const {
    return (*this).list.max_size();
  }

  // top

  template <typename V, typename A, typename R, typename I, typename J>
  V&
  list_based_stack<V, A, R, I, J>::top() {
    return (*this).list.front();
  }
	
  template <typename V, typename A, typename R, typename I, typename J>
  V const&
  list_based_stack<V, A, R, I, J>::top() const {
    return (*this).list.front();
  }

  // push

  template <typename V, typename A, typename R, typename I, typename J>
  void
  list_based_stack<V, A, R, I, J>::push(V const& v) {
    (*this).list.push_front(v);
  }
	
  // pop

  template <typename V, typename A, typename R, typename I, typename J>
  void
  list_based_stack<V, A, R, I, J>::pop() {
    (*this).list.pop_front();
  }

  // clear

  template <typename V, typename A, typename R, typename I, typename J>
  void
  list_based_stack<V, A, R, I, J>::clear() {
    (*this).list.clear();		
  }
	
  // swap

  template <typename V, typename A, typename R, typename I, typename J>
  void
  list_based_stack<V, A, R, I, J>::swap(list_based_stack<V, A, R, I, J>& c) {
    (*this).list.swap(c.list);
  }

}
