namespace cphstl {

  // default constructor

  template <typename V>
  list_node<V>::list_node() 
    : previous(this), next(this) {
  }

  // parametrized constructor

  template <typename V>
  list_node<V>::list_node(V const& v, list_node* p, list_node* s) 
    : previous(p), next(s), value(v) {
  }

  // destructor

  template <typename V>
  list_node<V>::~list_node() {
  }

  // predecessor

  template <typename V>
  list_node<V>* list_node<V>::predecessor() const {
    return (*this).previous;
  }

  template <typename V>
  list_node<V>*& list_node<V>::predecessor() {
    return (*this).previous;
  }

  // successor

  template <typename V>
  list_node<V>* list_node<V>::successor() const {
    return (*this).next;
  }

  template <typename V>
  list_node<V>*& list_node<V>::successor() {
    return (*this).next;
  }

  // content

  template <typename V>
  V const&
  list_node<V>::content() const {
    return (*this).value;
  }

  template <typename V>
  V&
  list_node<V>::content() {
    return (*this).value;
  }

}
