namespace cphstl {
  // explicit constructor

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  map_base<K, V, C, A, R, I, J>::map_base(C const& comparator, A const& allocator) 
    : set_base<K, V, C, A, R, I, J>(comparator, allocator) {
  }

  // parametrized constructor

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  template <typename X>
  map_base<K, V, C, A, R, I, J>::map_base(X p, X q, C const& comparator, A const& allocator)
    : set_base<K, V, C, A, R, I, J>(p, q, comparator, allocator) {
  }

  // copy constructor
  
  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  map_base<K, V, C, A, R, I, J>::map_base(map_base const& other) : set_base<K, V, C, A, R, I, J>(other) {
  }

  // destructor
  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  map_base<K, V, C, A, R, I, J>::~map_base() {
  }

  // lower_bound

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  typename map_base<K, V, C, A, R, I, J>::iterator
  map_base<K, V, C, A, R, I, J>::lower_bound(K const& k) {
    return (*this).kernel.lower_bound(k);
  }

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  typename map_base<K, V, C, A, R, I, J>::const_iterator
  map_base<K, V, C, A, R, I, J>::lower_bound(K const& k) const {
    return (*this).kernel.lower_bound(k);
  }

  // upper_bound

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  typename map_base<K, V, C, A, R, I, J>::iterator
  map_base<K, V, C, A, R, I, J>::upper_bound(K const& k) {
    return (*this).kernel.upper_bound(k);
  }
  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  typename map_base<K, V, C, A, R, I, J>::const_iterator
  map_base<K, V, C, A, R, I, J>::upper_bound(K const& k) const {
    return (*this).kernel.upper_bound(k);
  }

  // equal_range

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  std::pair<typename map_base<K, V, C, A, R, I, J>::iterator, 
            typename map_base<K, V, C, A, R, I, J>::iterator>
  map_base<K, V, C, A, R, I, J>::equal_range(K const& k) {
    return std::make_pair((*this).lower_bound(k), (*this).upper_bound(k));
  }

  template <typename K, typename V, typename C, typename A, typename R, typename I, typename J>
  std::pair<typename map_base<K, V, C, A, R, I, J>::const_iterator, 
            typename map_base<K, V, C, A, R, I, J>::const_iterator>
  map_base<K, V, C, A, R, I, J>::equal_range(K const& k) const {
    return std::make_pair((*this).lower_bound(k), (*this).upper_bound(k));
  }

}
