namespace cphstl {
  template <typename C>
  class comparator_proxy {
  public:
    typedef typename C::first_argument_type first_argument_type;
    typedef typename C::second_argument_type second_argument_type;

    comparator_proxy() {
      (*this).c = new C();
    }
    comparator_proxy(C& c) {
      (*this).c = new C(c);
    }
    comparator_proxy(comparator_proxy& cp) {
      (*this).c = new C(*cp.c);
    }
    comparator_proxy operator=(comparator_proxy const& cp) {
      delete (*this).c;
      (*this).c = new C(*cp.c);
      return (*this);
    }
    comparator_proxy operator=(C const& c) {
      delete (*this).c;
      (*this).c = new C(c);
      return (*this);
    }
    ~comparator_proxy() {
      delete (*this).c;
    }
    bool operator()(const first_argument_type& t1, const second_argument_type& t2) const {
      return (*(*this).c)(t1, t2);
    }
    C& subject() const {
      return (*(*this).c);
    }
  private:
    C* c;
  };
}

