#ifndef __CPHSTL_DIRECT_ENCAPSULATOR__
#define __CPHSTL_DIRECT_ENCAPSULATOR__

/*
  A direct encapsulator encapsulates an element, nothing else.

  Author: Bo Simonsen © 2008, 2009
*/

#include <cstddef> // defines std::size_t and std::ptrdiff_t

namespace cphstl {

  template <typename V, typename A>
  class direct_encapsulator {

  public:
    typedef V value_type;
    typedef A allocator_type;
    typedef direct_encapsulator slot_type;
    typedef direct_encapsulator* segment_type;
    enum {size = sizeof(value_type) };

    direct_encapsulator(value_type const& _v) : v(_v) {
    }

    direct_encapsulator(direct_encapsulator const& a) : v(a.v) {
    }

    const value_type& content() const {
      return v;
    }

    value_type& content() {
      return v;
    }

  private:
    value_type v;
  };
}
#endif
