#ifndef __CPHSTL_GENERAL_SURROGATE__
#define __CPHSTL_GENERAL_SURROGATE__

/*
  The surrogate keeps a pointer to some subject. For example, in the
  vector framework an iterator keeps a pointer to a kernel surrogate.
  This is done in order to maintain referential integrity when
  swapping two vectors.

  Author: Bo Simonsen © 2009
*/

namespace cphstl {

  template <typename S>
  class general_surrogate {
  public:

    typedef S subject_type;

    subject_type*& subject() {
      return ptr;
    }

  private:

    subject_type* ptr;
  };
}

#endif
