#ifndef __CPHSTL_SURROGATE__
#define __CPHSTL_SURROGATE__

/*
  The surrogate keeps a pointer to the kernel. The vector_framework
  keeps a pointer to the surrogate, which is used for creating iterators. 
  The purpose of the surrogate is to maintain referential integrity when
  performing swap().

  Author: Bo Simonsen © 2009
*/

namespace cphstl {
  template <typename F>
  class surrogate  {
  public:
    typedef F container_type;

    container_type*& subject() {
      return ptr;
    }
  private:
    container_type* ptr;
  };

}

#endif
