#include "direct-encapsulator.h++"
#include "indirect-encapsulator.h++"
#include "doubly-indirect-encapsulator.h++"

#define NEW_ENCAPSULATOR_FAMILY(f) template <typename V, typename A, typename E> \
  class f##_classes { \
  public: \
    enum {positive = 0}; \
  };

#define JOIN_ENCAPSULATOR_FAMILY(f, c) template <typename V, typename A> \
  class f##_classes< V, A, c <V, A> > { \
  public: \
    enum {positive = 1}; \
  };

#ifdef __GXX_EXPERIMENTAL_CXX0X__
#define IS_ENCAPSULATOR_IN_FAMILY(e, f) static_assert( \
  f##_classes<typename e::value_type, typename e::allocator_type, e>::positive == 1, \
  "Encapsulator "  #e " is not in family _" #f "_" \
);
#else
#define IS_ENCAPSULATOR_IN_FAMILY(e, f)
#endif

namespace cphstl {
  NEW_ENCAPSULATOR_FAMILY(proxy)
  NEW_ENCAPSULATOR_FAMILY(rank)
  JOIN_ENCAPSULATOR_FAMILY(proxy, doubly_indirect_encapsulator)
  JOIN_ENCAPSULATOR_FAMILY(proxy, indirect_encapsulator)
  JOIN_ENCAPSULATOR_FAMILY(rank, direct_encapsulator)
}
