/* 

   Test program for the named template argument preprocessor. 

   The preprocessor should be invoked by:

     python nta.py -I<includedir> -I ... search-tree-framework-test.c++

   Author: Bo Simonsen, June 2009

*/

#include "node-iterator.h++"
#include "stl_set.h++"
#include "stl_map.h++"
#include "stl_multiset.h++"
#include "stl_multimap.h++"
#include "tree.h++"
#include "red_black_tree_balance.h++"
#include "red_black_tree_node.h++"
#include "red_black_tree_bp_node.h++"
#include "splay_tree_balance.h++"
#include "splay_tree_node.h++"
#include "avl_tree_balance.h++"
#include "avl_tree_node.h++"
#include "avl_tree_bp_node.h++"
#include "aa_tree_node.h++"
#include "aa_tree_balance.h++"

int main() {
  typedef cphstl::set!<V=int,
                       R=cphstl::tree!<
                         N=cphstl::avl_tree_node!<se=true!>,
                         B=cphstl::avl_tree_balance_policy
                       !>,
                       I=cphstl::node_iterator!<is_const=false!>,
                       J=cphstl::node_iterator!<is_const=true!>
                     !> SC;
  typedef cphstl::map!<K=char,
                       V=int,
                       A=std::allocator<std::pair<char, int> >,
                       R=cphstl::tree!<
                         V=std::pair<char, int>,
                         F=cphstl::unnamed::key_functor,
                         N=cphstl::aa_tree_node,
                         B=cphstl::aa_tree_balance_policy
                       !>,
                       I=cphstl::node_iterator!<is_const=false!>,
                       J=cphstl::node_iterator!<is_const=true!>
                     !> MC;
  typedef cphstl::multiset!<V=int,
                       R=cphstl::tree!<
                         N=cphstl::red_black_tree_node,
                         B=cphstl::red_black_tree_balance_policy,
                         is_multiset=true
                       !>,
                       I=cphstl::node_iterator!<is_const=false!>,
                       J=cphstl::node_iterator!<is_const=true!>
                     !> MSC;
  typedef cphstl::multimap!<K=char,
                       V=int,
                       A=std::allocator<std::pair<char, int> >,
                       R=cphstl::tree!<
                         V=std::pair<char, int>,
                         F=cphstl::unnamed::key_functor,
                         N=cphstl::splay_tree_node,
                         B=cphstl::splay_tree_balance_policy,
                         is_multiset=true
                       !>,
                       I=cphstl::node_iterator!<is_const=false!>,
                       J=cphstl::node_iterator!<is_const=true!>
                     !> MMC;

  SC sc;
  MC mc;
  MSC msc;
  MMC mmc;

  for(int i=0; i < 10; ++i) {
    sc.insert(i);
    msc.insert(i);
    mc[(char) i + 65] = i;
    mmc.insert(std::pair<char, int>((char) i + 65, i));
  }
}
