/* 

   Test program for the named template argument preprocessor. 

   The preprocessor should be invoked by:

     python nta.py -I<includedir> -I ... search-tree-framework-test.c++

   Author: Bo Simonsen, June 2009

*/

#include <memory> // defines std::allocator
#include "stl-vector.h++" // defines cphstl::vector
#include "vector-framework.h++"
#include "dynamic-array.h++" // defines cphstl::dynamic_array_kernel
#include "hashed-array-tree.h++" // defines cphstl::dynamic_array_kernel
#include "indirect-encapsulator.h++" // defines cphstl::dynamic_array_kernel
#include "doubly-indirect-encapsulator.h++" // defines cphstl::dynamic_array_kernel
#include "proxy-iterator.h++" // defines cphstl::rank_iterator
#include "rank-iterator.h++" // defines cphstl::rank_iterator
#include <list>

int main() {
  typedef cphstl::vector!<V=int, 
                          R=cphstl::vector_framework!<
                            K=cphstl::hashed_array_tree!<
                              E=cphstl::doubly_indirect_encapsulator
                            !>
                          !>, 
                          I=cphstl::proxy_iterator!<is_const=false!>, 
                          J=cphstl::proxy_iterator!<is_const=true!>
                        !> C;
  C v;
  for(int i=0; i < 10; i++) {
    v.insert(v.begin(), i);
  }
  
  C::iterator it = v.begin();
  int i = 9;
  while(it != v.end()) {
    assert(*it == i);
    ++it; --i;
  }
}
